#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
#include "uss.h"
#include "chouonpa.h"

void chouonpa(){
    long uss_l, uss_r;
    int flag_l = 0, flag_r = 0;
    int rote = 0;
	
	//if(uss_open_l() != 0) return -1;
	//if(uss_open_r() != 0) return -1;
    
	if(uss_open_l() != 0){ //超音波センサ起動
		printf(" left uss open faild !!\n");
		flag_l = -1;
	}
	if(uss_open_r() != 0){
		printf(" right uss open faild !!\n");
		flag_r = -1;
	}
    if( flag_l == -1 && flag_r == -1) return -1;
    
        uss_l = uss_get_l();//超音波センサで左の値を取得,値を変数に格納
	usleep(500 * 1000);
		
	uss_r = uss_get_r();//超音波センサで右の値を取得,値を変数に格納
	usleep(500 * 1000);
		
	//printf("uss_l = %6ld, uss_r = %6ld\n", uss_l, uss_r);
	//usleep(10 * 1000);
    
    if(uss_l > 30 || uss_r > 30){ //障害物有無の条件判定、障害物が正面にあったとき
	//条件式は仮の値
	rote = 0;
	yokeru(int rote); //よける関数
    }else if(uss_l > 30 || uss_r < 30){//障害物有無の条件判定、障害物が右にあった時
	//条件式は仮の値
	rote = 1;
	yokeru(int rote); //よける関数
    }else if(uss_l < 30 || uss_r > 30){//障害物有無の条件判定、障害物が左にあった時
	//条件式は仮の値
	rote = 2;
	yokeru(int rote); //よける関数
    }else{//障害物が検知されなかったとき
	rote = 11;
        yokeru(int rote); //よける関数
    }
    
    
    
    
}
void yokeru(int rote){
    
    request_set_runmode(STP, 0, 0);//停止処理
    sleep(1);
    switch(rote){
	case 0: //正面に障害物があるとき
	    request_set_runmode(ROT, 45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, -45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, -45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, 45, 45);
	    sleep(2);
	    break;
	case 1: //右に障害物があるとき
	    request_set_runmode(ROT, 45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, -45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, -45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, 45, 45);
	    sleep(2);
	    break;
	case 2: //左に障害物があるとき
	    request_set_runmode(ROT, -45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, 45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, 45, 45);
	    sleep(2);
	    request_set_runmode(STR, 50, 50);
	    sleep(2);
	    request_set_runmode(ROT, -45, 45);
	    sleep(2);
	    break;
	default : //何もないとき

	    break;
        
    }
        
   
    
    
    
}
